<template>
    <div class="player-video">
        <video-player  class="video-player-box"
                       ref="videoPlayer"
                       :options="playerOptions"
                       :playsinline="true"
                       customEventName="customstatechangedeventname"

                       @canplaythrough="onPlayerCanplaythrough($event)"

                       @statechanged="playerStateChanged($event)"
                       @loadedmetadata="console.log('metas')"
                       @loadeddata="onPlayerLoadeddata($event)"
                       @ready="playerReadied">
        </video-player>
        <div class="player-back-progress" ref="progress" v-if="archive" @click="progressClick">
            <div class="point" ref="point"></div>
            <div class="progress-val" ref="value"></div>
        </div>
    </div>
</template>

<script>
    import 'video.js/dist/video-js.css'

    import { videoPlayer } from 'vue-video-player'

    // videojs
    import videojs from 'video.js'
    window.videojs = videojs;
    require('videojs-contrib-hls/dist/videojs-contrib-hls.js');



    require ('videojs-hotkeys');

    export default {
        props: {
            link: {
                required: true,
            },
            archive: {
                required: true,
            },
            range: {
                required: false,
            }
        },
        name: "ChannelPlayer",
        components: {
            videoPlayer
        },
        data() {
            return {
                linkSufix: '',
            }
        },
        mounted() {
            console.log('this is current player instance object', this.player)
        },
        computed: {
            player() {
                return this.$refs.videoPlayer.player
            },
            playerLink() {
                return this.link + this.linkSufix;
            },
            playerOptions() {
                return {
                    autoplay: true,
                    muted: false,
                    language: 'ru',
                    responsive: true,
                    preload: true,
                    fluid: true,
                    sources: [{
                        withCredentials: false,
                        type: "application/x-mpegURL",
                        src: this.playerLink
                    }],
                    controlBar: {
                        volumePanel: {
                            inline: false
                        },
                        timeDivider: true,
                        durationDisplay: true,
                        qualityLevels: true,
                        muteToggle: true,
                        progressControl: true,
                    },
                    time: 360,
                    // height: 1080,
                    // width: 1920,
                    aspectRatio: "16:9",
                    flash: { hls: { withCredentials: false }},
                    html5: { hls: { withCredentials: true  }},
                    poster: "/images/logo.png"
                }
            }
        },
        methods: {
            // listen event
            onPlayerPlay(player) {
                // console.log('player play!', player)
            },
            onPlayerPause(player) {
                // console.log('player pause!', player)
            },
            // ...player event

            onPlayerCanplaythrough(event) {

            },

            onPlayerLoadeddata(player) {
                this.$emit('statistic');
                console.log('player Loadeddata!', player)
            },
            // or listen state event
            playerStateChanged(playerCurrentState) {
                // console.log('player current update state', playerCurrentState)
            },

            playerReadied(player) {

                var hls = player.tech({ IWillNotUseThisInPlugins: true }).hls;
                console.log('player',player);

                player.hotkeys({
                    volumeStep: 1,
                    seekStep: 5,
                    enableVolumeScroll: true,
                    enableHoverScroll: true,
                    enableQualityLevels: true,
                    enableModifiersForNumbers: false,
                    fullscreenKey: function(event, player) {
                        // override fullscreen to trigger when pressing the F key or Ctrl+Enter
                        return ((event.which === 70) || (event.ctrlKey && event.which === 13));
                    }
                });

                player.tech_.hls.xhr.beforeRequest = function(options) {
                    return options
                }
            },

            progressClick(event) {
                let pPos = this.$refs.progress.getBoundingClientRect().left,
                    pWidth = this.$refs.progress.offsetWidth,
                    leftPos = event.clientX - pPos;
                this.$refs.point.style.left = leftPos+'px';
                this.$refs.value.style.width = leftPos+'px';

                let range = this.range * 3600000;
                let timeNow = Date.now();
                let timeForPixel = range/pWidth;
                let back  = (pWidth-leftPos)*timeForPixel;
                let duration = timeNow - back;

                if (pWidth-leftPos > 3) {
                    this.linkSufix = '&start='+Math.floor(duration/1000);
                    this.$emit('timeshift',Math.floor(duration));
                } else {
                    this.$emit('online');
                }

                // console.log('click');
            }
        }
    }
</script>

<style lang="scss">
    .video-player-box {
        /*width: 100% !important;*/
        /*height: calc( (100vw - 150px)*9 /16) !important;*/
        /*max-height: calc(100vh - 230px);*/
    }
    .vjs-poster {
        background-color: #478dcd !important;
        background-size: 250px !important;
    }

    .video-js * {
        outline: none !important;
        text-shadow: none;
    }

    .player-video {
        position: relative;

        .player-back-progress {
            opacity: 0;
            width: calc(100% - 40px);
            height: 8px;
            position: absolute;
            left: 20px;
            bottom: 35px;
            background: rgba(255, 255, 255, 0.5);
            z-index: 5;
            transition-delay: 2s;
            transition-duration: 0.8s;

            .point {
                position: absolute;
                top: 50%;
                left: 100%;
                width: 12px;
                height: 12px;
                background: #fff;
                margin-top: -6px;
                margin-left: -6px;
                border-radius: 50%;
            }
            .progress-val {
                background: #0a4882;
                height: 8px;
                width: 100%;
            }
        }

        &:hover {
            .player-back-progress {
                transition-delay: 0s;
                opacity: 1;
            }
        }
    }

    .video-player-box .video-js .vjs-tech {
        object-fit: fill;
    }
    @media (max-width: 600px) {
        .video-js {
            height: calc( (100vw - 50px)*9 /16) !important;
        }
    }
</style>
